<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009" 
		  xmlns:s="library://ns.adobe.com/flex/spark" 
		  xmlns:mx="library://ns.adobe.com/flex/mx"
		  title="Abrir caixa Dia seguinte"
		  creationComplete="titlewindow1_creationCompleteHandler(event)"
		  close="titlewindow1_closeHandler(event)" xmlns:visual="br.com.desenv.framework.component.visual.*"
		  
		  >
	<fx:Style source="../../../framework/util/estilo.css"/>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			import mx.utils.StringUtil;
			
			import br.com.desenv.nepalign.vo.Usuario;
			
			protected function titlewindow1_closeHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);				
			}
			
			protected function titlewindow1_creationCompleteHandler(event:FlexEvent):void
			{
				var usuario:Usuario = FlexGlobals.topLevelApplication.usuarioLogado;
				if(usuario.usuarioMaster != "S")
				{
					Alert.show("Usuário sem perfil de acesso para essa tela!","Erro!",Alert.OK,this,verificacaoUsuairoMaster);
				}
			}
			protected function verificacaoUsuairoMaster(e:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);	
			}
			
			protected function btnConfirmar_clickHandler(event:MouseEvent):void
			{
				if(this.validar()=="ok")
				{
					var data:Date = DateField.stringToDate(this.ignTextInputDateData.text,"DD/MM/YYYY");
					if(data.getDay()==0)
					{
						Alert.show("É domingo! Deseja continuar?","Aviso!",Alert.YES|Alert.NO,this,domingoResultClose);
					}
					else
					{
						var ro:RemoteObject = AMFConnector.instance.prepararObjetoRemoto("caixaDiaService", this.verificarFeriadoResultHandler);
						ro.getOperation("verificarFeriado").send(data);
					}
				}
				else
				{
					Alert.show(""+this.validar());
				}
				
			}
			
			protected function verificarFeriadoResultHandler(event:ResultEvent):void
			{
				var resultado:Boolean = event.result as Boolean;
				if(resultado)
				{
					Alert.show("É FERIADO. Deseja Continuar?","AVISO", Alert.YES|Alert.NO, this, domingoResultClose);
				}
				else
				{
					var ro:RemoteObject = AMFConnector.instance.prepararObjetoRemoto("caixaDiaService", this.salvarResult);
					ro.getOperation("abrirCaixaDiaSeguinte").send(DateField.stringToDate(this.ignTextInputDateData.text,"DD/MM/YYYY"),FlexGlobals.topLevelApplication.usuarioLogado);
				}
			}
			protected function domingoResultClose(e:CloseEvent):void
			{
				if(e.detail == Alert.YES)
				{
					var ro:RemoteObject = AMFConnector.instance.prepararObjetoRemoto("caixaDiaService", this.salvarResult);
					ro.getOperation("abrirCaixaDiaSeguinte").send(DateField.stringToDate(this.ignTextInputDateData.text,"DD/MM/YYYY"),FlexGlobals.topLevelApplication.usuarioLogado);
					
				}
			}
			protected function salvarResult(e:ResultEvent):void
			{
				Alert.show("Salvo Com sucesso!","Aviso");
			}
			protected function validar():String
			{
				if(StringUtil.trim(this.ignTextInputDateData.text) =="")
				{
					return "Campo data vazio!";
				}
				var data:Date = DateField.stringToDate(this.ignTextInputDateData.text,"DD/MM/YYYY");
				var hj:Date = DateField.stringToDate(DateField.dateToString(new Date(),"DD/MM/YYYY"),"DD/MM/YYYY");
				if(data.getTime()==hj.getTime())
				{
					return "Não é possivel abrir caixa para a data de hoje!";
				}
				var diasBaixa:int = parseInt(((DateField.stringToDate(this.ignTextInputDateData.text,"DD/MM/YYYY").getTime() -new Date().getTime())/(1000 * 60 * 60 * 24)).toString());
				if(diasBaixa>4)
				{
					return "Data com diferença maior que 4 dias!";
				}
				
				return "ok";
			}
		]]>
	</fx:Script>
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
	</fx:Declarations>
	<mx:Grid>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Data Caixa que deseja abrir:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<visual:IgnTextInputDate  id="ignTextInputDateData" obrigatorio="false" />
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
				<s:Button id="btnConfirmar" label="Confimar" click="btnConfirmar_clickHandler(event)" />
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>	
</s:TitleWindow>
